package superHat
{
	function GameConnection::spawnPlayer(%client)
	{
		parent::spawnPlayer(%client);
		if(%client.superHat)
		{
			for(%I=0;%I<4;%I++)
				if(isObject(%im = %client.superhat[%I]))
					%client.player.mountImage(%im,%I);
		}
	}
	function Player::mountImage(%this,%image,%slot,%a,%b)
	{
		if(%this.client.superHat && isObject(%this.client.superHat[%slot]) && %this.client.superHat[%slot] !$= %image)
			return;
		parent::mountImage(%this,%image,%slot,%a,%b);
	}
	function Player::unMountImage(%this,%slot)
	{
		if(%this.client.superHat && isObject(%this.client.superHat[%slot]))
			return;
		parent::unMountImage(%this,%slot);
	}
}; activatepackage(superHat);

function servercmdSuperHat(%client, %op, %id, %hat)
{
	if((%id < 0 || %id > 3 || %id $= "") && (%op !$= "get" && %op !$= "toggle"))
	{
		%client.chatMessage("\c6ID Out of range");
		%client.chatMessage("\c6Usage, /SuperHat [toggle/set/get/remove] [ID] [hat]");
		return;
	}
	switch$(%op)
	{
		case "toggle":
			%client.superhat = !%client.superhat;
			%client.chatMessage("\c6SuperHat is now \c2"@ (!%client.superHat ? "Disabled" : "Enabled"));
		case "get":
			for(%i=0;%i<4;%I++)
				%client.chatMessage("\c6Hat["@ %i @"] is"SPC (isObject(%client.superhat[%i]) ? fileBase(%client.superhat[%i].shapeFile) : "unused"));
			return;
		case "set":
			if(!isObject(%hatt = %hat))
				if(!isObject(%hatt = "hat"@ %hat @"data"))
				{
					%client.chatMessage("\c6Could not find hat "@ %hat);
					return;
				}
			if(!isHat(%hat))
			{
				%client.chatMessage("\c6That is not a hat!");
				return;
			}
			%client.superhat[%id] = %hatt;
		case "remove":
			%client.superhat[%id] = "";
			%client.chatMessage("\c6Removed hat "@ %id);
		default:
			%client.chatMessage("\c6Usage, /SuperHat [toggle/set/get] [ID] [hat]");
			return;
	}
	if(isObject(%player = %client.player))
	{
		for(%I=0;%I<4;%I++)
			if(isObject(%im = %client.superhat[%I]) && %client.superhat)
				%client.player.mountImage(%im,%I);
			else %client.player.unMountImage(%i);
	}
}